@Echo off
setlocal

echo FLASHER UTILITY BY SKIPFIE. TO BE USED WITH SKIPPAD.

for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Leonardo"') do (
    call :resetCOM "%%~J"
    goto :EOF
)

for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "USB Serial Device"') do (
    call :resetCOM "%%~J"
    goto :EOF
)

echo ERROR 1 NO DEVICE. SEND LOG.TXT TO DISCORD FOR SUPPORT.
goto :error

:continue

:: wmic /format:list strips trailing spaces (at least for path win32_pnpentity)
for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Leonardo bootloader"') do (
    call :setCOM "%%~J"
    goto :EOF
)

for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "Arduino Micro bootloader"') do (
    call :setCOM "%%~J"
    goto :EOF
)

for /f "tokens=1* delims==" %%I in ('wmic path win32_pnpentity get caption  /format:list ^| find "USB Serial Device"') do (
    call :setCOM "%%~J"
    goto :EOF
)

:: end main batch
echo ERROR 2 BOOTLOADER NOT FOUND. SEND LOG.TXT TO DISCORD FOR SUPPORT.
goto :error

:resetCOM <WMIC_output_line>
:: sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%
echo %port%
mode %port%: BAUD=1200 parity=N data=8 stop=1
echo WAITING 3 SECONDS FOR SKIPPAD TO RECONNECT
ping 127.0.0.1 -n 4 > nul
goto :continue

:setCOM <WMIC_output_line>
:: sets _COM#=line
setlocal
set "str=%~1"
set "num=%str:*(COM=%"
set "num=%num:)=%"
set port=COM%num%
echo %port%
goto :flash

:flash
start /b /w "" "%cd%\avrdude.exe" -v -C./avrdude.conf -p atmega32u4 -c avr109 -P%port% -b57600 -V -D -Uflash:w:./firmware.hex:a
if ERRORLEVEL 1 echo SOMETHING WENT WRONG. POST LOG.TXT TO DISCORD FOR SUPPORT.
echo FIRMWARE UPDATED. && echo. && echo DONE, CHECK IF IT HAS UPDATED PROPERLY IN LOG.TXT! EXIT NOW!
pause
goto :EOF

:error
echo UNKNOWN ERROR. SEND LOG.TXT TO DISCORD FOR SUPPORT.
goto :EOF